net.sf.saxon.expr

## Class SubsequenceIterator

- java.lang.Object
- - net.sf.saxon.expr.SubsequenceIterator

- All Implemented Interfaces:
    LastPositionFinder, SequenceIterator, LookaheadIterator

      public class SubsequenceIterator
      extends Object
      implements SequenceIterator, LastPositionFinder, LookaheadIterator

  A SubsequenceIterator selects a subsequence of a sequence

- - ### Field Summary

    - ### Fields inherited from interface net.sf.saxon.om.SequenceIterator

      `GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Close the iterator.
    `Item` | `current()` Get the current value in the sequence (the one returned by the most recent call on next()).
    `SequenceIterator` | `getAnother()` Get another iterator to return the same nodes
    `int` | `getLength()` Get the last position (that is, the number of items in the sequence).
    `int` | `getProperties()` Get properties of this iterator, as a bit-significant integer.
    `boolean` | `hasNext()` Test whether there are any more items available in the sequence
    `static SequenceIterator` | `make(SequenceIterator base, int min, int max)` Static factory method.
    `Item` | `next()` Get the next item if there is one
    `int` | `position()` Get the current position.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### make

          public static SequenceIterator make(SequenceIterator base,
                              int min,
                              int max)
                                       throws XPathException

      Static factory method. Creates a SubsequenceIterator, unless for example the base Iterator is an ArrayIterator, in which case it optimizes by creating a new ArrayIterator directly over the underlying array. This optimization is important when doing recursion over a node-set using repeated calls of $nodes[position()>1]
      Parameters:
        `base` - An iteration of the items to be filtered
        `min` - The position of the first item to be included (base 1)
        `max` - The position of the last item to be included (base 1)
      Returns:
        an iterator over the requested subsequence
      Throws:
        `XPathException`

    - #### hasNext

          public boolean hasNext()

      Test whether there are any more items available in the sequence
      Specified by:
        `hasNext` in interface `LookaheadIterator`
      Returns:
        true if there are more items in the sequence

    - #### next

          public Item next()
                    throws XPathException

      Get the next item if there is one
      Specified by:
        `next` in interface `SequenceIterator`
      Returns:
        the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.
      Throws:
        `XPathException` - if an error occurs retrieving the next item

    - #### current

          public Item current()

      Description copied from interface: `SequenceIterator`
      Get the current value in the sequence (the one returned by the most recent call on next()). This will be null before the first call of next(). This method does not change the state of the iterator.
      Specified by:
        `current` in interface `SequenceIterator`
      Returns:
        the current item, the one most recently returned by a call on next(). Returns null if next() has not been called, or if the end of the sequence has been reached.

    - #### position

          public int position()

      Description copied from interface: `SequenceIterator`
      Get the current position. This will usually be zero before the first call on next(), otherwise it will be the number of times that next() has been called. Once next() has returned null, the preferred action is for subsequent calls on position() to return -1, but not all existing implementations follow this practice. (In particular, the EmptyIterator is stateless, and always returns 0 as the value of position(), whether or not next() has been called.)

      This method does not change the state of the iterator.

      Specified by:
        `position` in interface `SequenceIterator`
      Returns:
        the current position, the position of the item returned by the most recent call of next(). This is 1 after next() has been successfully called once, 2 after it has been called twice, and so on. If next() has never been called, the method returns zero. If the end of the sequence has been reached, the value returned will always be <= 0; the preferred value is -1.

    - #### close

          public void close()

      Description copied from interface: `SequenceIterator`
      Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

      (Currently, closing an iterator is important only when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.)

      Specified by:
        `close` in interface `SequenceIterator`

    - #### getAnother

          public SequenceIterator getAnother()
                                      throws XPathException

      Get another iterator to return the same nodes
      Specified by:
        `getAnother` in interface `SequenceIterator`
      Returns:
        a SequenceIterator that iterates over the same items, positioned before the first item
      Throws:
        `XPathException` - if any error occurs

    - #### getProperties

          public int getProperties()

      Get properties of this iterator, as a bit-significant integer.
      Specified by:
        `getProperties` in interface `SequenceIterator`
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

    - #### getLength

          public int getLength()
                        throws XPathException

      Get the last position (that is, the number of items in the sequence). This method is non-destructive: it does not change the state of the iterator. The result is undefined if the next() method of the iterator has already returned null. This method must not be called unless the result of getProperties() on the iterator includes the bit setting `SequenceIterator.LAST_POSITION_FINDER`
      Specified by:
        `getLength` in interface `LastPositionFinder`
      Returns:
        the number of items in the sequence
      Throws:
        `XPathException` - if an error occurs evaluating the sequence in order to determine the number of items

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.